Program DBG64;
(*
Copyright (C) 1996-98  Paul Toth (tothpaul@mygale.org)

http://www.mygale.org/~tothpaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)
{$R-,S-,I-,Q-}
{$D-,L-,Y-}

uses
 DOS,CRT;

Const
 Info:string='*** C=64 EMULATOR BY PAUL TOTH ***';
{
DacArray         Db    00,00,00 ; Black
                 Db    63,63,63 ; White
                 Db    50,00,00 ; Red
                 Db    00,63,63 ; Cyan
                 Db    63,00,63 ; Purple
                 Db    00,50,00 ; Green
                 Db    00,00,50 ; Blue
                 Db    63,63,00 ; Yellow

                 Db    63,25,00 ; Orange
                 Db    48,25,00 ; Brown
                 Db    63,25,25 ; Light red
                 Db    16,16,16 ; Gray 1
                 Db    32,32,32 ; Gray 2
                 Db    25,63,25 ; Light green
                 Db    25,25,60 ; Light blue
                 Db    48,48,48 ; Gray 3
 Black         0 *
 Blue          1 *
 Green         2 *
 Cyan          3 *
 Red           4 *
 Magenta       5 Purple
 Brown         6 *
 LightGray     7 Gray1

 Light Colors:
(Foreground)
 
 DarkGray       8 Gray2
 LightBlue      9 *
 LightGreen    10 *
 LightCyan     11 -
 LightRed      12 *
 LightMagenta  13 -
 Yellow        14 *
 White         15 *
}
 COLOR:array[0..15] of byte=(
  Black,White,Red,Cyan,Magenta,Green,Blue,Yellow,
  LightMagenta,Brown,LightRed,DarkGray,LightGray,
  LightGreen,LightBlue,LightCyan
 );

Var
 CHARSET:array[0..255] of byte;

Type
 TParm=(
  pImpl, { no parameters }
  pAbso, { word }
  pZPge, { byte }
  pImm,  { #byte }
  pAbsX, { word+x }
  pAbsY, { word+y }
  pIndX, { [byte+x] = array[x]^ }
  pIndY, { [byte]+y = array^[y] }
  pZPgX, { byte+x }
  pZPgY, { byte+y }
  pRela, { shortint(byte) }
  pInd   { [word] }
 );

 TOpCode=record
  Name:array[1..3] of char;
  Parm:TParm;
 end;

Const
 OpCode:Array[0..255] of TOpCode = (
 {00-0F}
  (Name:'BRK'; Parm:pImpl),  (Name:'ORA'; Parm:pIndX),
  (Name:'JAM'; Parm:pImpl),  (Name:'SLO'; Parm:pIndX),
  (Name:'NOP'; Parm:pImpl),  (Name:'ORA'; Parm:pZPge),
  (Name:'ASL'; Parm:pZPge),  (Name:'SLO'; Parm:pZPge),
  (Name:'PHP'; Parm:pImpl),  (Name:'ORA'; Parm:PImm),
  (Name:'ASL'; Parm:pImpl),  (Name:'ANC'; Parm:pImpl),
  (Name:'   '; Parm:pImpl),  (Name:'ORA'; Parm:pAbso),
  (Name:'ASL'; Parm:pAbso),  (Name:'   '; Parm:pImpl),
 {10-1F}
  (Name:'BPL'; Parm:pRela),  (Name:'ORA'; Parm:pIndY),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'   '; Parm:pImpl),  (Name:'ORA'; Parm:pZPgX),
  (Name:'ASL'; Parm:pZPgX),  (Name:'   '; Parm:pImpl),
  (Name:'CLC'; Parm:pImpl),  (Name:'ORA'; Parm:pAbsY),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'   '; Parm:pImpl),  (Name:'ORA'; Parm:pAbsX),
  (Name:'ASL'; Parm:pAbsX),  (Name:'   '; Parm:pImpl),
 {20-2F}
  (Name:'JSR'; Parm:pAbso),  (Name:'AND'; Parm:pIndX),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'BIT'; Parm:pZPge),  (Name:'AND'; Parm:pZPge),
  (Name:'ROL'; Parm:pZPge),  (Name:'   '; Parm:pImpl),
  (Name:'PLP'; Parm:pImpl),  (Name:'AND'; Parm:PImm),
  (Name:'ROL'; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'BIT'; Parm:pAbso),  (Name:'AND'; Parm:pAbso),
  (Name:'ROL'; Parm:pAbso),  (Name:'   '; Parm:pImpl),
 {30-3F}
  (Name:'BMI'; Parm:pRela),  (Name:'AND'; Parm:pIndY),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'   '; Parm:pImpl),  (Name:'AND'; Parm:pZPgX),
  (Name:'ROL'; Parm:pZPgX),  (Name:'   '; Parm:pImpl),
  (Name:'SEC'; Parm:pImpl),  (Name:'AND'; Parm:pAbsY),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'   '; Parm:pImpl),  (Name:'AND'; Parm:pAbsX),
  (Name:'ROL'; Parm:pAbsX),  (Name:'   '; Parm:pImpl),
 {40-4F}
  (Name:'RTI'; Parm:pImpl),  (Name:'EOR'; Parm:pIndX),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'   '; Parm:pImpl),  (Name:'EOR'; Parm:pZPge),
  (Name:'LSR'; Parm:pZPge),  (Name:'   '; Parm:pImpl),
  (Name:'PHA'; Parm:pImpl),  (Name:'EOR'; Parm:pImm ),
  (Name:'LSR'; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'JMP'; Parm:pAbso),  (Name:'EOR'; Parm:pAbso),
  (Name:'LSR'; Parm:pAbso),  (Name:'   '; Parm:pImpl),
 {50-5F}
  (Name:'BVC'; Parm:pRela),  (Name:'EOR'; Parm:pIndY),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'   '; Parm:pImpl),  (Name:'EOR'; Parm:pZPgX),
  (Name:'LSR'; Parm:pZPgX),  (Name:'   '; Parm:pImpl),
  (Name:'CLI'; Parm:pImpl),  (Name:'EOR'; Parm:pAbsY),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'   '; Parm:pImpl),  (Name:'EOR'; Parm:pAbsX),
  (Name:'LSR'; Parm:pAbsX),  (Name:'   '; Parm:pImpl),
 {60-6F}
  (Name:'RTS'; Parm:pImpl),  (Name:'ADC'; Parm:pIndX),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'   '; Parm:pImpl),  (Name:'ADC'; Parm:pZPge),
  (Name:'ROR'; Parm:pZPge),  (Name:'   '; Parm:pImpl),
  (Name:'PLA'; Parm:pImpl),  (Name:'ADC'; Parm:PImm),
  (Name:'ROR'; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'JMP'; Parm:pInd ),  (Name:'ADC'; Parm:pAbso),
  (Name:'ROR'; Parm:pAbso),  (Name:'   '; Parm:pImpl),
 {70-7F}
  (Name:'BVS'; Parm:pRela),  (Name:'ADC'; Parm:pIndY),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'   '; Parm:pImpl),  (Name:'ADC'; Parm:pZPgX),
  (Name:'ROR'; Parm:pZPgX),  (Name:'   '; Parm:pImpl),
  (Name:'SEI'; Parm:pImpl),  (Name:'ADC'; Parm:pAbsY),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'   '; Parm:pImpl),  (Name:'ADC'; Parm:pAbsX),
  (Name:'ROR'; Parm:pAbsX),  (Name:'   '; Parm:pImpl),
 {80-8F}
  (Name:'   '; Parm:pImpl),  (Name:'STA'; Parm:pIndX),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'STY'; Parm:pZPge),  (Name:'STA'; Parm:pZPge),
  (Name:'STX'; Parm:pZPge),  (Name:'   '; Parm:pImpl),
  (Name:'DEY'; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'TXA'; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'STY'; Parm:pAbso),  (Name:'STA'; Parm:pAbso),
  (Name:'STX'; Parm:pAbso),  (Name:'   '; Parm:pImpl),
 {90-9F}
  (Name:'BCC'; Parm:pRela),  (Name:'STA'; Parm:pIndY),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'STY'; Parm:pZPgX),  (Name:'STA'; Parm:pZPgX),
  (Name:'STX'; Parm:pZPgY),  (Name:'   '; Parm:pImpl),
  (Name:'TYA'; Parm:pImpl),  (Name:'STA'; Parm:pAbsY),
  (Name:'TXS'; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'   '; Parm:pImpl),  (Name:'STA'; Parm:pAbsX),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
 {A0-AF}
  (Name:'LDY'; Parm:PImm),   (Name:'LDA'; Parm:pIndX),
  (Name:'LDX'; Parm:PImm),   (Name:'   '; Parm:pImpl),
  (Name:'LDY'; Parm:pZPge),  (Name:'LDA'; Parm:pZPge),
  (Name:'LDX'; Parm:pZPge),  (Name:'   '; Parm:pImpl),
  (Name:'TAY'; Parm:pImpl),  (Name:'LDA'; Parm:PImm),
  (Name:'TAX'; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'LDY'; Parm:pAbso),  (Name:'LDA'; Parm:pAbso),
  (Name:'LDX'; Parm:pAbso),  (Name:'   '; Parm:pImpl),
 {B0-BF}
  (Name:'BCS'; Parm:pRela),  (Name:'LDA'; Parm:pIndY),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'LDY'; Parm:pZPgX),  (Name:'LDA'; Parm:pZpgX),
  (Name:'LDX'; Parm:pZPgY),  (Name:'   '; Parm:pImpl),
  (Name:'CLV'; Parm:pImpl),  (Name:'LDA'; Parm:pAbsY),
  (Name:'TSX'; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'LDY'; Parm:pAbsX),  (Name:'LDA'; Parm:pAbsX),
  (Name:'LDX'; Parm:pAbsY),  (Name:'   '; Parm:pImpl),
 {C0-CF}
  (Name:'CPY'; Parm:pImm ),  (Name:'CMP'; Parm:pIndX),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'CPY'; Parm:pZPge),  (Name:'CMP'; Parm:pZPge),
  (Name:'DEC'; Parm:pZPge),  (Name:'   '; Parm:pImpl),
  (Name:'INY'; Parm:pImpl),  (Name:'CMP'; Parm:PImm),
  (Name:'DEX'; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'CPY'; Parm:pAbso),  (Name:'CMP'; Parm:pAbso),
  (Name:'DEC'; Parm:pAbso),  (Name:'   '; Parm:pImpl),
 {D0-DF}
  (Name:'BNE'; Parm:pRela),  (Name:'CMP'; Parm:pIndY),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'DEC'; Parm:pZPgX),  (Name:'   '; Parm:pImpl),
  (Name:'CLD'; Parm:pImpl),  (Name:'CMP'; Parm:pAbsY),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'   '; Parm:pImpl),  (Name:'CMP'; Parm:pAbsX),
  (Name:'DEC'; Parm:pAbsX),  (Name:'   '; Parm:pImpl),
 {E0-EF}
  (Name:'CPX'; Parm:PImm),   (Name:'SBC'; Parm:pIndX),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'CPX'; Parm:pZPge),  (Name:'SBC'; Parm:pZPge),
  (Name:'INC'; Parm:pZPge),  (Name:'   '; Parm:pImpl),
  (Name:'INX'; Parm:pImpl),  (Name:'SBC'; Parm:PImm),
  (Name:'NOP'; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'CPX'; Parm:pAbso),  (Name:'SBC'; Parm:pAbso),
  (Name:'INC'; Parm:pAbso),  (Name:'   '; Parm:pImpl),
 {F0-FF}
  (Name:'BEQ'; Parm:pRela),  (Name:'SBC'; Parm:pIndY),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'   '; Parm:pImpl),  (Name:'SBC'; Parm:pZPgX),
  (Name:'INC'; Parm:pZPgX),  (Name:'   '; Parm:pImpl),
  (Name:'SED'; Parm:pImpl),  (Name:'SBC'; Parm:pAbsY),
  (Name:'   '; Parm:pImpl),  (Name:'   '; Parm:pImpl),
  (Name:'   '; Parm:pImpl),  (Name:'SBC'; Parm:pAbsX),
  (Name:'INC'; Parm:pAbsX),  (Name:'   '; Parm:pImpl)
  );


var
 f:file;
 size:word;
 emul:pointer;
 code:pointer;
 ram :pointer;
 rom :pointer;
 i:integer;

Const
 Hexa:array[0..$F] of char='0123456789ABCDEF';

Procedure PutHexaB(B:Byte; Var data);
 Var
  HexaB:Array[0..1] of char absolute Data;
 begin
  HexaB[0]:=Hexa[B SHR 4];
  HexaB[1]:=Hexa[B AND $F];
 end;

Procedure PutHexaW(W:Word;Var data);
 var
  hexaw:array[0..1] of word absolute data;
 begin
  PutHexaB(W SHR   8,hexaw[0]);
  PutHexaB(W AND $FF,hexaw[1]);
 end;

Function HexaB(B:Byte):string;
 begin
  HexaB:=Hexa[B SHR 4]+Hexa[B AND $F];
 end;

Function HexaW(W:Word):string;
 begin
  HexaW:=HexaB(W SHR 8)+HexaB(W AND $FF);
 end;

Function GetWord(Addr:word):word;
 begin
  case addr of
   $0000..$9FFF : GetWord:=MemW[Seg(Ram^):Addr];
   $A000..$BFFF : GetWord:=MemW[Seg(Rom^):Addr];
   $C000..$CFFF : GetWord:=MemW[Seg(Ram^):Addr];
   $D000..$DFFF : GetWord:=MemW[Seg(Code^):Addr];
   $E000..$FFFF : GetWord:=MemW[Seg(Rom^):Addr];
  end;
 end;

Function GetByte(Addr:word):byte;
 begin
  case addr of
   $0000..$9FFF : GetByte:=Mem[Seg(Ram^):Addr];
   $A000..$BFFF : GetByte:=Mem[Seg(Rom^):Addr];
   $C000..$CFFF : GetByte:=Mem[Seg(Ram^):Addr];
   $D000..$DFFF : GetByte:=Mem[Seg(Code^):Addr];
   $E000..$FFFF : GetByte:=Mem[Seg(Rom^):Addr];
  end;
 end;

Function Value(Addr:word):string;
 begin
  Value:='= $'+HexaB(GetByte(Addr));
 end;

Function GetBreakPoint:word;
 var
  key:char;
  val:byte;
  result:word;
 begin
  Write('Goto : $');
  val:=0;
  result:=0;
  repeat
   key:=readkey;
   case key of
    #0:readkey;
    #8:if val>0 then begin dec(val); result:=result div 16; write(key) end;
    '0'..'9':if val<4 then begin
              inc(val);
              result:=result*16+(ord(key)-ord('0'));
              write(key);
             end;
    'A'..'F':if val<4 then begin
              inc(val);
              result:=result*16+(ord(key)-ord('A')+10);
              write(key);
             end;
    'a'..'f':if val<4 then begin
              inc(val);
              result:=result*16+(ord(key)-ord('a')+10);
              write(upcase(key));
             end;
   end;
  until (key=#13)and(val=4);
  WriteLn;
  GetBreakPoint:=result;
 end;

Procedure PutKey(DS:word;Key:byte);
 Const
 { PC Keys remaped for C=64 : 'a'->'A'; 'A'->'a'... }
  Keys:array[0..255] of byte=(
   $00,$01,$02,$03,$04,$05,$06,$07,$14,$03,$0A,$0B,$0C,$0D,$0E,$0F,$10,$11,
   $12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,$20,$21,$22,$23,
   $24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,$30,$31,$32,$33,$34,$35,
   $36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F,$40,$61,$62,$63,$64,$65,$66,$67,
   $68,$69,$6A,$6B,$6C,$6D,$6E,$6F,$70,$71,$72,$73,$74,$75,$76,$77,$78,$79,
   $7A,$5B,$5C,$5D,$5E,$5F,$60,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,
   $4C,$4D,$4E,$4F,$50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$7B,$7C,$7D,
   $7E,$7F,$80,$81,$82,$83,$84,$85,$86,$87,$88,$89,$8A,$8B,$8C,$8D,$8E,$83,
   $90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9A,$9B,$5C,$9D,$9E,$9F,$A0,$A1,
   $A2,$A3,$A4,$A5,$A6,$A7,$A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF,$B0,$B1,$B2,$B3,
   $B4,$B5,$B6,$B7,$B8,$B9,$BA,$BB,$BC,$BD,$BE,$BF,$C0,$C1,$C2,$C3,$C4,$C5,
   $C6,$13,$91,$12,$CA,$9D,$CC,$1D,$CE,$CF,$11,$92,$94,$D3,$D4,$D5,$D6,$D7,
   $D8,$D9,$DA,$DB,$DC,$DD,$DE,$DF,$E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,
   $EA,$EB,$EC,$ED,$EE,$EF,$F0,$F1,$F2,$F3,$F4,$F5,$F6,$93,$F8,$F9,$FA,$FB,
   $FC,$5F,$FE,$FF
  );
 Var
  Count:byte;
 begin
 { Keyboard buffer key count }
  Count:=Mem[DS:$C6];
 { Keyboard buffer }
  Mem[DS:$277+Count]:=Keys[Key];
 { Update count }
  Mem[DS:$C6]:=Count+1;
 end;

type
  TC64regs=record
{
 A DW 0
 X DW 0
 Y DW 0
 S DW 1FFh
 P DB 0

 Align 2
 PC DW 0FCE2h
}
   a,x,y,s:word;
   p :set of (Cflag,ZFlag,IFlag,DFlag,BFlag,_Flag,VFlag,NFlag);
   a2:byte;
   pc:word;
  end;

var
  Dump:string;
{  f:byte; }
  x,y:integer;
  o1,o2,c:word;
  key:byte;
  k:char;
  C64regs:^TC64regs;


procedure DEBUG(Flags, CS, IP, AX, BX, CX, DX, SI, DI, DS, ES, BP: Word);
interrupt;


 const
  flag:array[0..7] of char='nv_bdizc';
  stop:boolean=true;
  breakpoint:word=0;
  echo:boolean=true;
  return:word=0;
  raster:word=238;
  irq:boolean=false;

  c64kb:boolean=false;

  procedure SwitchEcho;
   begin
    echo:=not echo;
    if echo then begin
     mem[SegB800:2*(10*80+11)]:=ord('N');
     mem[SegB800:2*(10*80+12)]:=ord(' ');
    end else begin
     mem[SegB800:2*(10*80+11)]:=ord('F');
     mem[SegB800:2*(10*80+12)]:=ord('F');
    end;
   end;

  procedure SwitchKbd;
   begin
    c64kb:=not c64kb;
    if c64kb then begin
     mem[SegB800:2*(11*80+19)]:=ord('N');
     mem[SegB800:2*(11*80+20)]:=ord(' ');
    end else begin
     mem[SegB800:2*(11*80+19)]:=ord('F');
     mem[SegB800:2*(11*80+20)]:=ord('F');
    end;
    TextColor(LightRed);
    WriteLn('Press <Esc> to restore PC keyboard...');
    stop:=false;
   end;

 begin

  TextColor(White);

  if AX=1 then begin
   if echo then Writeln('POKE ',HexaW(DI),',',HexaB(Lo(BX)));
   exit;
  end;

  if AX=2 then begin
   if echo then Writeln('PEEK ',HexaW(DI),'=',HexaB(Lo(BX)));
   exit;
  end;

  if AX=3 then begin
   if echo then Writeln('DEEK ',HexaW(DI),'=',HexaW(BX));
   exit;
  end;

  if AX=4 then begin { display screen }
   y:=(integer(BX)-51) div 8; { Raster }

   o1:=238+160*y;
   o2:=40*y;

   mem[SegB800:raster]:=32;
   raster:=o1-2;
   mem[SegB800:raster]:=16;

   c:=COLOR[Mem[Seg(Code^):$D021] AND 15] SHL 12;
   for x:=0 to 39 do
    MemW[SegB800:o1+2*x{2*(80*y+x)}]:=
     c+COLOR[Mem[Seg(Code^):DX+x] and 15] SHL 8+
     CHARSET[Mem[Seg(Code^):DX+40+X]];
   exit;
  end;

  { Info }
  if AX=5 then begin
   C64Regs:=ptr(CS,DI);
   For x:=1 to length(Info) do
    if Info[x] in ['A'..'Z'] then Dec(Info[x],Ord('@'));
   FillChar(mem[Seg(Ram^):$400],25*40,' ');
   Move(Info[1],mem[Seg(Ram^):$400+43],Length(Info));
   FillChar(mem[Seg(Code^):$D800],25*40,14);
   Mem[Seg(Code^):$D012]:=0;
   Mem[Seg(Code^):$D021]:=6;
   exit;
  end;

  if AX=6 then begin
   if echo then WriteLn(#16' NMI [FFFA]=',HexaW(GetWord($FFFA)));
   IRQ:=True;
  { stop:=true; }
   exit;
  end;

  if AX=7 then begin
   if echo then WriteLn(#16' IRQ [FFFE]=',HexaW(GetWord($FFFE)));
   IRQ:=True;
   {stop:=true;}
   exit;
  end;

  if AX=8 then begin
   if echo then begin
    Write('Setup Timer (DC0E) ');
    if (BX and 1) = 1 then Write('A') else write('a');
    if (BX and 2) = 2 then Write('B') else write('b');
    if (BX and 4) = 4 then Write('C') else write('c');
    WriteLn;
   end;
   exit;
  end;

  if AX=9 then begin
   if echo then begin
    Write(#16'CIA Emulation ');
    if (BX and 1) = 1 then Write('A') else write('a');
    if (BX and 2) = 2 then Write('B') else write('b');
    if (BX and 4) = 4 then Write('C') else write('c');
    WriteLn(' TimerA1 = ',DX,' - ',CX);
   end;
{   if (not (IFlag in C64Regs^.P))and(dx<cx) then stop:=true; }
   exit;
  end;

  if AX=10 then begin
   if echo then begin
    Write('IRQ Mask (DC0D) ');
    if (BX and 1) = 1 then Write('A') else write('a');
    if (BX and 2) = 2 then Write('B') else write('b');
    WriteLn;
   end;
  { stop:=true; }
   exit;
  end;

  if c64kb then begin
   if keypressed then begin
    key:=ord(readkey); if key=0 then key:=128+ord(readkey);
    if key=27 then begin
     stop:=true;
     c64kb:=false;
    end else begin
     putkey(Seg(Ram^),key);
     exit;
    end;
   end else
    exit;
  end;

  if keypressed then stop:=true;

  if SI=breakpoint+1 then stop:=true;

  if (return>0) then
   if (DX=$60) then begin
    dec(return);
    if return=0 then stop:=true;
   end else
    if (OpCode[DX].Name='JSR') then inc(return);

  if echo or stop then begin

        {         1         2         3         4     }
        {1...:....0....:....0....:....0....:....0....:}
  Dump:='PC=xxxx OP=xx A=xx X=xx Y=xx P=nv_bdizc S=1xx ';

  with C64Regs^ do begin

   TextColor(Red);
   if A>255 then begin writeln('WARNING A=',HexaW(A)); stop:=true; end;
   if X>255 then begin writeln('WARNING X=',HexaW(X)); stop:=true; end;
   if Y>255 then begin writeln('WARNING Y=',HexaW(Y)); stop:=true; end;
   if S<256 then begin writeln('WARNING S=',HexaW(S)); stop:=true; end;
   TextColor(White);

   PutHexaW(PC,Dump[ 4]);
   PutHexaB(DX,Dump[12]);
   PutHexaB(A ,Dump[17]);
   PutHexaB(X ,Dump[22]);
   PutHexaB(Y ,Dump[27]);

   if CFlag in P then Dump[39]:='C';
   if ZFlag in P then Dump[38]:='Z';
   if IFlag in P then Dump[37]:='I';
   if DFlag in P then Dump[36]:='D';
   if BFlag in P then Dump[35]:='B';

   if VFlag in P then Dump[33]:='V';
   if NFlag in P then Dump[32]:='N';

   PutHexaB(S AND $FF,Dump[44]);


  With OpCode[DX] do begin
   Dump:=Dump+Name+' ';
   Case Parm of
    pImpl : { nothing };
    pAbso : Dump:=Dump+ '$'+HexaW(BX)+'   '+Value(BX);
    pZPge : Dump:=Dump+ '$'+HexaB(Lo(BX))+'     '+Value(Lo(BX));
    pImm  : Dump:=Dump+'#$'+HexaB(Lo(BX));
    pAbsX : Dump:=Dump+ '$'+HexaW(BX)+'+X'+' '+Value(BX+X);
    pAbsY : Dump:=Dump+ '$'+HexaW(BX)+'+Y'+' '+Value(BX+Y);
    pIndX : Dump:=Dump+'($'+HexaB(Lo(BX))+'+X'+' '+Value(GetWord(Lo(BX)+X));
    pIndY : Dump:=Dump+'($'+HexaB(Lo(BX))+')+Y'+' '+Value(GetWord(Lo(BX))+Y);
    pZPgX : Dump:=Dump+ '$'+HexaB(Lo(BX))+'+X'+' '+Value(Lo(BX)+X);
    pZPgY : Dump:=Dump+ '$'+HexaB(Lo(BX))+'+Y'+' '+Value(Lo(BX)+Y);
    pRela : Dump:=Dump+ '$'+HexaW(PC+2+ShortInt(Lo(BX)));
    pInd  : Dump:=Dump+'($'+HexaW(BX)+')';
   end;
  end;

  case PC of
   $A408 : WriteLn(#16' Check Memory');
   $AB1E : WriteLn(#16' Print string at AY');
   $B487 : WriteLn(#16' Get string');
   $E394 : WriteLn(#16' BASIC Reset');
   $E3BF : WriteLn(#16' Init BASIC Interpretor');
   $E422 : WriteLn(#16' BASIC Message');
   $E453 : WriteLn(#16' Init vectors $0300-$030B');
   $E4DA : WriteLn(#16' Set Color');
   $E518 : WriteLn(#16' Init Keyboard & Video');
   $E56C : WriteLn(#16' Set current line addr');
   $E5A0 : WriteLn(#16' Init Video');
   $E716 : WriteLn(#16' Output char to screen (device 3)');
   $E7D4 : WriteLn(#16' put MAJ on screen');
   $E9F0 : WriteLn(#16' Compute Char offset from X');
   $E9FF : WriteLn(#16' Clear line');
   $EA24 : WriteLn(#16' Compute Color offset');
   $EA31 : WriteLn(#16' Standard IRQ routine');
   $EA87 : WriteLn(#16' Check keyboard');
   $EE8E : Writeln(#16' Clock = 1');
   $EEA9 : WriteLn(#16' ');
   $F69B : WriteLn(#16' Incr. Real Time Clock');
   $FCE2 : WriteLn(#16' C=64 Entry point');
   $FCEF : WriteLn(#16' (no cartridge)');
   $FD02 : WriteLn(#16' Detect cartridge');
   $FD15 : WriteLn(#16' Restore I/O vectors');
   $FD1A : WriteLn(#16' Set I/O Vectors from XY');
   $FD50 : WriteLn(#16' Init z-page & search ROM');
   $FDA3 : WriteLn(#16' Reset I/O');
   $FDDD : WriteLn(#16' Check monitor');
   $FF5B : WriteLn(#16' Init I/O');
   $FF5E : WriteLn(#16' Wait retrace');
   $FF6E : WriteLn(#16' Set IRQs to 1/60s');
   $FF9C : WriteLn(#16' [Get/Set Bottom of memory]');
   $FF99 : WriteLn(#16' [Get/Set Top of memory]');
   $FFCF : WriteLn(#16' Start BASIC');
   $FFD2 : WriteLn(#16' [Output char]');
  end;

  if irq then TextColor(LightGreen) else TextColor(Yellow);
  if Dump[47]='J' then Dump[0]:=#57;
  WriteLn(Dump);
(*
  if DX in [$08,$20,$28,$48,$60,$68] then begin

   write('STACK : ');
   for i:=S+1 to $1FE do write(HexaB(Mem[Seg(Ram^):i]),',');
   writeLn(HexaB(Mem[Seg(Ram^):$1FF]));

  end;
*)
  end; { Regs }

  if DX=$40 then irq:=false;

  end; { echo }


  if not stop then exit;

  repeat
   write('?'); k:=readkey; write(#8);
   case k of
    'r','R'     : begin BreakPoint:=0; stop:=false; end;
    'p','P'     : with OpCode[DX] do
                   if Name='JSR' then begin
                    BreakPoint:=SI+2; stop:=false;
                   end else begin
                    if Parm<>pRela then exit;
                    BreakPoint:=SI+1; stop:=false;
                   end;
    'b','B'     : begin
                   if OpCode[DX].Parm<>pRela then exit;
                   BreakPoint:=SI+1+ShortInt(GetByte(SI));
                   stop:=false;
                  end;
    's','S'     : begin
                   if OpCode[DX].Parm<>pRela then exit;
                   BreakPoint:=SI;
                   stop:=false;
                  end;
    'x','X'     : begin return:=1; stop:=false end;
    'e','E'     : SwitchEcho;
    'k','K'     : SwitchKbd;
    't','T',#13 : exit;
    'q','Q',#27 : halt;
            #0  : readkey;
        'g','G' : begin BreakPoint:=GetBreakPoint; stop:=false; end;
   end;
  until stop=false;

  if not echo then writeln('running...');

 end;


var
 OldExit:pointer;
 OldI64 :pointer;

 procedure NewExit; far;
  begin
   ExitProc:=OldExit;
   SetIntVec($64,OldI64);
   freemem(emul,$ffff);
   freemem(rom ,$ffff);
   freemem(ram ,$ffff);
   Window(1, 1, 80, 50);
   GotoXY(1,50); TextAttr:=$07;ClrEOL;
   GotoXY(1,49);
  end;

begin
{$i-}
 assign(f,'cbm64.dbg');
 reset(f,1);

 if ioresult<>0 then begin
  WriteLn('CBM64.DBG not found !');
  WriteLn('Note : build CBM64.ASM with DEBUG = 1 to build the debug pgm');
  exit;
 end;

 size:=filesize(f);

 getmem(emul,$FFFF);
 getmem(ram ,$FFFF);
 getmem(rom ,$FFFF);

{ verify memory allocation ! }
 if (ofs(emul^)<>0)
 or (ofs(ram^) <>0)
 or (ofs(rom^) <>0) then exit;

 if (seg(rom^)-seg(ram^ )<>$1000)
 or (seg(ram^)-seg(emul^)<>$1000) then exit;

{ build ASCII->PSET }
 For x:=0 to 255 do CHARSET[x]:=x;
 For X:=0 to 26  do CHARSET[x]:=Ord('@')+x;
 CHARSET[Ord('')]:=ord('');

{ Draw Screen }
 TextMode(CO80+Font8x8);
 TextAttr:=$07;
 ClrScr;
 WriteLn('C=64 interractive debugger');
 WriteLn('');
 WriteLn;
 WriteLn(' T = Trace');
 WriteLn(' P = Proceed (skip)');
 WriteLn(' B = Branch  (proceed until)');
 WriteLn(' S = Skip    (proceed until)');
 WriteLn(' X = eXit    (until RET)');
 WriteLn(' G = Goto');
 WriteLn(' R = Run');
 WriteLn(' E = Echo ON');
 WriteLn(' K = C64 Keyboard OFF');
 WriteLn(' Q = Quit');
 GotoXY(1,25);
 WriteLn('Copyright (C) 1997-98, Paul TOTH');
 WriteLn(' <tothpaul@mygale.org>');
 Window(39,1,80,27);
 TextAttr:=$31; clrscr;
 Window(40,2,79,26);
 TextAttr:=$10; ClrScr;
 Window(1,28,80,50);
 TextAttr:=$1E; clrscr;
 Window(2,29,79,49);


 code:=ptr(seg(emul^),ofs(emul^)+$100);

 blockread(f,code^,size);
 close(f);

 OldExit:=ExitProc;
 ExitProc:=@NewExit;

 GetIntVec($64,OldI64);
 SetIntVec($64,@DEBUG);

 asm
  mov ax,offset @SaveSS
  les di,emul
  mov word ptr (@jump+3), es

  mov byte ptr [es:di],  $EA { jump far }
  mov word ptr [es:di+1], ax { offset   }
  mov word ptr [es:di+3], cs { segment  }
  mov word ptr [es:$FFFE], 0 { return 0 }

  push ds
  push bp

  mov  ax,ss
  mov  word(@saveSS+1),ax
  mov  word(@saveSP+1),sp

  mov  ax,word(emul+2)
  mov  ds,ax
  mov  es,ax
  mov  ss,ax
  mov  sp,$FFFE

  @jump : db $EA,$00,$01,$00,$00

@saveSS:
  mov  ax,0
  mov  ss,ax
@saveSP:
  mov  sp,0

  pop  bp
  pop  ds

 end;


 Writeln(#16' Emulator terminated');
end.
