Program MakeCPU;
(*
Copyright (C) 1996-98  Paul Toth (tothpaul@mygale.org)

http://www.mygale.org/~tothpaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)
Var
 nz:boolean;

Type
 TOpCode=record
  Name:array[1..3] of char;
  Parm:array[1..4] of char;
 end;

Const
 OpCode:Array[0..255] of TOpCode = (
 {00-0F}
  (Name:'BRK'; Parm:'Impl'),  (Name:'ORA'; Parm:'IndX'),
  (Name:'JAM'; Parm:'Impl'),  (Name:'SLO'; Parm:'IndX'),
  (Name:'NOP'; Parm:'Impl'),  (Name:'ORA'; Parm:'ZPge'),
  (Name:'ASL'; Parm:'ZPge'),  (Name:'SLO'; Parm:'ZPge'),
  (Name:'PHP'; Parm:'Impl'),  (Name:'ORA'; Parm:'Imm'),
  (Name:'ASL'; Parm:'Impl'),  (Name:'ANC'; Parm:'Impl'),
  (Name:'   '; Parm:'    '),  (Name:'ORA'; Parm:'Abso'),
  (Name:'ASL'; Parm:'Abso'),  (Name:'   '; Parm:'    '),
 {10-1F}
  (Name:'BPL'; Parm:'Rela'),  (Name:'ORA'; Parm:'IndY'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'   '; Parm:'    '),  (Name:'ORA'; Parm:'ZPgX'),
  (Name:'ASL'; Parm:'ZPgX'),  (Name:'   '; Parm:'    '),
  (Name:'CLC'; Parm:'Impl'),  (Name:'ORA'; Parm:'AbsY'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'   '; Parm:'    '),  (Name:'ORA'; Parm:'AbsX'),
  (Name:'ASL'; Parm:'AbsX'),  (Name:'   '; Parm:'    '),
 {20-2F}
  (Name:'JSR'; Parm:'Abso'),  (Name:'AND'; Parm:'IndX'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'BIT'; Parm:'ZPge'),  (Name:'AND'; Parm:'ZPge'),
  (Name:'ROL'; Parm:'ZPge'),  (Name:'   '; Parm:'    '),
  (Name:'PLP'; Parm:'Impl'),  (Name:'AND'; Parm:'Imm'),
  (Name:'ROL'; Parm:'Impl'),  (Name:'   '; Parm:'    '),
  (Name:'BIT'; Parm:'Abso'),  (Name:'AND'; Parm:'Abso'),
  (Name:'ROL'; Parm:'Abso'),  (Name:'   '; Parm:'    '),
 {30-3F}
  (Name:'BMI'; Parm:'Rela'),  (Name:'AND'; Parm:'IndY'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'   '; Parm:'    '),  (Name:'AND'; Parm:'ZPgX'),
  (Name:'ROL'; Parm:'ZPgX'),  (Name:'   '; Parm:'    '),
  (Name:'SEC'; Parm:'Impl'),  (Name:'AND'; Parm:'AbsY'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'   '; Parm:'    '),  (Name:'AND'; Parm:'AbsX'),
  (Name:'ROL'; Parm:'AbsX'),  (Name:'   '; Parm:'    '),
 {40-4F}
  (Name:'RTI'; Parm:'Impl'),  (Name:'EOR'; Parm:'IndX'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'   '; Parm:'    '),  (Name:'EOR'; Parm:'ZPge'),
  (Name:'LSR'; Parm:'ZPge'),  (Name:'   '; Parm:'    '),
  (Name:'PHA'; Parm:'Impl'),  (Name:'EOR'; Parm:'Imm '),
  (Name:'LSR'; Parm:'Impl'),  (Name:'   '; Parm:'    '),
  (Name:'JMP'; Parm:'Abso'),  (Name:'EOR'; Parm:'Abso'),
  (Name:'LSR'; Parm:'Abso'),  (Name:'   '; Parm:'    '),
 {50-5F}
  (Name:'BVC'; Parm:'Rela'),  (Name:'EOR'; Parm:'IndY'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'   '; Parm:'    '),  (Name:'EOR'; Parm:'ZPgX'),
  (Name:'LSR'; Parm:'ZPgX'),  (Name:'   '; Parm:'    '),
  (Name:'CLI'; Parm:'Impl'),  (Name:'EOR'; Parm:'AbsY'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'   '; Parm:'    '),  (Name:'EOR'; Parm:'AbsX'),
  (Name:'LSR'; Parm:'AbsX'),  (Name:'   '; Parm:'    '),
 {60-6F}
  (Name:'RTS'; Parm:'Impl'),  (Name:'ADC'; Parm:'IndX'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'   '; Parm:'    '),  (Name:'ADC'; Parm:'ZPge'),
  (Name:'ROR'; Parm:'ZPge'),  (Name:'   '; Parm:'    '),
  (Name:'PLA'; Parm:'Impl'),  (Name:'ADC'; Parm:'Imm'),
  (Name:'ROR'; Parm:'Impl'),  (Name:'   '; Parm:'    '),
  (Name:'JMP'; Parm:'Ind '),  (Name:'ADC'; Parm:'Abso'),
  (Name:'ROR'; Parm:'Abso'),  (Name:'   '; Parm:'    '),
 {70-7F}
  (Name:'BVS'; Parm:'Rela'),  (Name:'ADC'; Parm:'IndY'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'   '; Parm:'    '),  (Name:'ADC'; Parm:'ZPgX'),
  (Name:'ROR'; Parm:'ZPgX'),  (Name:'   '; Parm:'    '),
  (Name:'SEI'; Parm:'Impl'),  (Name:'ADC'; Parm:'AbsY'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'   '; Parm:'    '),  (Name:'ADC'; Parm:'AbsX'),
  (Name:'ROR'; Parm:'AbsX'),  (Name:'   '; Parm:'    '),
 {80-8F}
  (Name:'   '; Parm:'    '),  (Name:'STA'; Parm:'IndX'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'STY'; Parm:'ZPge'),  (Name:'STA'; Parm:'ZPge'),
  (Name:'STX'; Parm:'ZPge'),  (Name:'   '; Parm:'    '),
  (Name:'DEY'; Parm:'Impl'),  (Name:'   '; Parm:'    '),
  (Name:'TXA'; Parm:'Impl'),  (Name:'   '; Parm:'    '),
  (Name:'STY'; Parm:'Abso'),  (Name:'STA'; Parm:'Abso'),
  (Name:'STX'; Parm:'Abso'),  (Name:'   '; Parm:'    '),
 {90-9F}
  (Name:'BCC'; Parm:'Rela'),  (Name:'STA'; Parm:'IndY'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'STY'; Parm:'ZPgX'),  (Name:'STA'; Parm:'ZPgX'),
  (Name:'STX'; Parm:'ZPgY'),  (Name:'   '; Parm:'    '),
  (Name:'TYA'; Parm:'Impl'),  (Name:'STA'; Parm:'AbsY'),
  (Name:'TXS'; Parm:'Impl'),  (Name:'   '; Parm:'    '),
  (Name:'   '; Parm:'    '),  (Name:'STA'; Parm:'AbsX'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
 {A0-AF}
  (Name:'LDY'; Parm:'Imm'),   (Name:'LDA'; Parm:'IndX'),
  (Name:'LDX'; Parm:'Imm'),   (Name:'   '; Parm:'    '),
  (Name:'LDY'; Parm:'ZPge'),  (Name:'LDA'; Parm:'ZPge'),
  (Name:'LDX'; Parm:'ZPge'),  (Name:'   '; Parm:'    '),
  (Name:'TAY'; Parm:'Impl'),  (Name:'LDA'; Parm:'Imm'),
  (Name:'TAX'; Parm:'Impl'),  (Name:'   '; Parm:'    '),
  (Name:'LDY'; Parm:'Abso'),  (Name:'LDA'; Parm:'Abso'),
  (Name:'LDX'; Parm:'Abso'),  (Name:'   '; Parm:'    '),
 {B0-BF}
  (Name:'BCS'; Parm:'Rela'),  (Name:'LDA'; Parm:'IndY'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'LDY'; Parm:'ZPgX'),  (Name:'LDA'; Parm:'ZpgX'),
  (Name:'LDX'; Parm:'ZPgY'),  (Name:'   '; Parm:'    '),
  (Name:'CLV'; Parm:'Impl'),  (Name:'LDA'; Parm:'AbsY'),
  (Name:'TSX'; Parm:'Impl'),  (Name:'   '; Parm:'    '),
  (Name:'LDY'; Parm:'AbsX'),  (Name:'LDA'; Parm:'AbsX'),
  (Name:'LDX'; Parm:'AbsY'),  (Name:'   '; Parm:'    '),
 {C0-CF}
  (Name:'CPY'; Parm:'Imm '),  (Name:'CMP'; Parm:'IndX'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'CPY'; Parm:'ZPge'),  (Name:'CMP'; Parm:'ZPge'),
  (Name:'DEC'; Parm:'ZPge'),  (Name:'   '; Parm:'    '),
  (Name:'INY'; Parm:'Impl'),  (Name:'CMP'; Parm:'Imm'),
  (Name:'DEX'; Parm:'Impl'),  (Name:'   '; Parm:'    '),
  (Name:'CPY'; Parm:'Abso'),  (Name:'CMP'; Parm:'Abso'),
  (Name:'DEC'; Parm:'Abso'),  (Name:'   '; Parm:'    '),
 {D0-DF}
  (Name:'BNE'; Parm:'Rela'),  (Name:'CMP'; Parm:'IndY'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'DEC'; Parm:'ZPgX'),  (Name:'   '; Parm:'    '),
  (Name:'CLD'; Parm:'Impl'),  (Name:'CMP'; Parm:'AbsY'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'   '; Parm:'    '),  (Name:'CMP'; Parm:'AbsX'),
  (Name:'DEC'; Parm:'AbsX'),  (Name:'   '; Parm:'    '),
 {E0-EF}
  (Name:'CPX'; Parm:'Imm'),   (Name:'SBC'; Parm:'IndX'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'CPX'; Parm:'ZPge'),  (Name:'SBC'; Parm:'ZPge'),
  (Name:'INC'; Parm:'ZPge'),  (Name:'   '; Parm:'    '),
  (Name:'INX'; Parm:'Impl'),  (Name:'SBC'; Parm:'Imm'),
  (Name:'NOP'; Parm:'Impl'),  (Name:'   '; Parm:'    '),
  (Name:'CPX'; Parm:'Abso'),  (Name:'SBC'; Parm:'Abso'),
  (Name:'INC'; Parm:'Abso'),  (Name:'   '; Parm:'    '),
 {F0-FF}
  (Name:'BEQ'; Parm:'Rela'),  (Name:'SBC'; Parm:'IndY'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'   '; Parm:'    '),  (Name:'SBC'; Parm:'ZPgX'),
  (Name:'INC'; Parm:'ZPgX'),  (Name:'   '; Parm:'    '),
  (Name:'SED'; Parm:'Impl'),  (Name:'SBC'; Parm:'AbsY'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'   '; Parm:'    '),  (Name:'SBC'; Parm:'AbsX'),
  (Name:'INC'; Parm:'AbsX'),  (Name:'   '; Parm:'    ')
  );

 OpCycles:array[0..255] of byte=(
   { 0 1 2 3 4 5 6 7 8 9 A B C D E F 0 1 2 3 4 5 6 7 8 9 A B C D E F}
{00} 7,6,0,0,0,3,5,0,3,2,2,0,0,4,6,0,2,5,0,0,0,4,6,0,2,4,0,0,0,4,7,0,
{20} 6,6,0,0,3,3,5,0,4,2,2,0,4,4,6,0,2,5,0,0,0,4,6,0,2,4,0,0,0,4,7,0,
{40} 6,6,0,0,0,3,5,0,3,2,2,0,3,4,6,0,2,5,0,0,0,4,6,0,2,4,0,0,0,4,7,0,
{60} 6,6,0,0,0,3,5,0,4,2,2,0,5,4,6,0,2,5,0,0,0,4,6,0,2,4,0,0,0,4,7,0,
{80} 0,6,0,0,3,3,3,0,2,0,2,0,4,4,4,0,2,5,0,0,4,4,4,0,2,4,2,0,0,4,0,0,
{A0} 2,6,2,0,3,3,3,0,2,2,2,0,4,4,4,0,2,5,0,0,4,4,4,0,2,4,2,0,4,4,4,0,
{C0} 2,6,0,0,3,3,5,0,2,2,2,0,4,4,6,0,2,5,0,0,0,4,6,0,2,4,0,0,0,4,7,0,
{E0} 2,6,0,0,3,3,5,0,2,2,2,0,4,4,6,0,2,5,0,0,0,4,6,0,2,4,0,0,0,4,7,0
 );

Var
 IR:byte;
 lbl:word;
 head:boolean;
 peek:boolean;

function hexa(b:byte):string;
 const
  hx:array[0..15] of char='0123456789ABCDEF';
 begin
  hexa:=hx[b shr 4]+hx[b and 15]
 end;

Procedure Header;
 begin
 (*
  WriteLn(';--',Hexa(IR),'--',OpCode[IR].Name,' ',OpCode[IR].Parm,'--',OpCycles[IR],'--');
  WriteLn('Align 2');
  WriteLn('op',Hexa(IR),':');
 *)
  if not head then begin
   WriteLn(';--',OpCode[IR].Name,' ',OpCode[IR].Parm,' ',OpCycles[IR],'--');
   WriteLn('OpCode ',Hexa(IR));
   head:=true;
  end;
 end;

Procedure Fetch;
 begin
  Header;
  WriteLn(' INC PC');
 end;

Procedure Next;
 begin
  writeln('; cycles');
  writeln(' MOV CX,',OpCycles[IR]);
  writeln('JMP Next');
 end;


Procedure SetFlag(Flag:string; on:boolean);
 begin
  Header;
  if on then
   WriteLn(' OR P,',Flag)
  else
   WriteLn(' AND P,255-',Flag);
  Next;
 end;

Procedure Set_NZ(Reg:String);
 begin
 (*
  Writeln('; Set_NZ');
  writeln(' OR AL,AL');
  writeln(' JZ lbl',lbl); inc(lbl);
  writeln('  TEST AL,NFlag');
  writeln('  JZ lbl',lbl); inc(lbl);
  writeln('   AND P,255-ZFlag');
  writeln('   OR  P,NFlag');
  writeln('  JMP lbl',lbl); inc(lbl);
  writeln(' lbl',lbl-2,':');
  writeln('  AND P,255-ZFlag-NFlag');
  writeln('  JMP lbl',lbl-1);
  writeln(' lbl',lbl-3,':');
  writeln('  AND P,255-NFlag');
  writeln('  OR  P,ZFlag');
  writeln(' lbl',lbl-1,':');
 *)
  if not nz then WriteLn(' Set_NZ ',Reg);
  nz:=true;
 end;

Procedure Push(Load:string);
 begin
  Header;
  writeln(load);
  WriteLn(' MOV BX,S');
  writeln(' MOV FS:[BX],AL');
  writeln(' DEC BX');
  writeln(' MOV S,BX');
 end;

procedure Pop(Store:string);
 begin
  Header;
  Writeln(' MOV BX,S');
  writeln(' INC BX');
  WriteLn(' MOV AL,FS:[BX]');
  writeln(' MOV S,BX');
  writeln(Store);
 end;

Procedure Imm;
 begin
  Header;
  WriteLn(' INC PC');
  WriteLn(' MOV AL,BL');
  WriteLn(' XOR AH,AH'); {------------------}
 end;

Procedure LDA;
 begin
  Header;
  WriteLn(' MOV AX,A');
 end;

Procedure LDX;
 begin
  Header;
  WriteLn(' MOV AX,X');
 end;

Procedure STX(Reg:String);
 begin
  WriteLn(' MOV BYTE PTR X,',Reg);
  Set_NZ(Reg);
  Next;
 end;

Procedure LDY;
 begin
  Header;
  WriteLn(' MOV AX,Y');
 end;

Procedure STY(Reg:string);
 begin
  WriteLn(' MOV BYTE PTR Y,',Reg);
  Set_NZ(Reg);
  Next;
 end;

Procedure STA(Reg:string);
 begin
  WriteLn(' MOV BYTE PTR A,',Reg);
  Set_NZ(Reg);
  Next;
 end;

Procedure PeekZPge;
 begin
  header;
  WriteLn('; peek zpge');
  writeln(' INC PC');
  writeln(' XOR BH,BH');
  writeln(' MOV AL,FS:[BX]');
  WriteLn(' XOR AH,AH'); {------------------}
  peek:=true;
 end;

Procedure PokeZPge;
 begin
  if not peek then writeln(' INC PC');
  WriteLn('; cycles');
  writeln(' MOV CX,',OpCycles[IR]);
  WriteLn('JMP PokeBX');
 end;

Procedure PeekZPgX;
 begin
  header;
  WriteLn('; peek zpgx');
  writeln(' INC PC');
  writeln(' XOR BH,BH');
  writeln(' ADD BX,X');
  writeln(' MOV AL,FS:[BX]');
  WriteLn(' XOR AH,AH'); {------------------}
  peek:=true;
 end;

Procedure PokeZPgX;
 begin
  WriteLn('; peek zpge');
  writeln(' INC PC');
  writeln(' XOR BH,BH');
  writeln(' ADD BX,X');
  writeln(' MOV CX,',OpCycles[IR]);
  writeln('JMP PokeBX');
 end;

Procedure PeekZPgY;
 begin
  header;
  WriteLn('; peek zpgy');
  writeln(' INC PC');
  writeln(' XOR BH,BH');
  writeln(' ADD BX,Y');
  writeln(' MOV AL,FS:[BX]');
  WriteLn(' XOR AH,AH'); {------------------}
  peek:=true;
 end;

Procedure PeekAbso;
 begin
  Header;
  WriteLn('; peek abso');
  writeln(' INC PC');
  writeln(' INC PC');
  writeln(' Call PeekBX ; AL');
{  WriteLn(' XOR AH,AH'); {------------------}
  peek:=true;
 end;

Procedure PeekAbsX;
 begin
  Header;
  WriteLn('; peek absx');
  Writeln(' INC PC');
  Writeln(' INC PC');
  WriteLn(' ADD BX,X');
  writeln(' Call PeekBX ; AL');
{  WriteLn(' XOR AH,AH'); {------------------}
 end;

Procedure PokeAbsX;
 begin
  WriteLn('; poke Absx');
  Writeln(' INC PC');
  Writeln(' INC PC');
  WriteLn(' ADD BX,X');
  WriteLn(' MOV CX,',OpCycles[IR]);
  writeln('JMP PokeBX ; AL');
 end;

Procedure PeekAbsY;
 begin
  Header;
  WriteLn('; peek absy');
  Writeln(' INC PC');
  Writeln(' INC PC');
  WriteLn(' ADD BX,Y');
  writeln(' Call PeekBX ; AL');
{  WriteLn(' XOR AH,AH'); {------------------}
 end;

Procedure PokeAbsY;
 begin
  WriteLn('; poke AbsY');
  Writeln(' INC PC');
  Writeln(' INC PC');
  WriteLn(' ADD BX,Y');
  WritELn(' MOV CX,',OpCycles[IR]);
  writeln('JMP PokeBX');
 end;

Procedure PokeAbso;
 begin
  if not peek then begin
   WriteLn(' INC PC');
   WriteLn(' INC PC');
  end;
  WriteLn('; cycles');
  writeln(' MOV CX,',OpCycles[IR]);
  writeln('JMP PokeBX');
 end;

Procedure PeekIndX;
 begin
  Header;
  WriteLn('; peek indx');
  WriteLn(' INC PC');
  WriteLn(' XOR BH,BH');
  WriteLn(' ADD BX,X');
  WriteLn(' Call DeekBX ; BX');
  WriteLn(' Call PeekBX ; AL');
{  WriteLn(' XOR AH,AH'); {------------------}
 end;

Procedure PokeIndX;
 begin
  WriteLn('; poke indx');
  WriteLn(' INC PC');
  WriteLn(' XOR BH,BH');
  WriteLn(' ADD BX,X');
  WriteLn(' Call DeekBX ; BX');
  writeln(' MOV CX,',OpCycles[IR]);
  WriteLn('JMP PokeBX ; AL');
 end;

Procedure PeekIndY;
 begin
  Header;
  WriteLn('; peek indy');
  WriteLn(' INC PC');
  WriteLn(' XOR BH,BH');
  WriteLn(' Call DeekBX ; BX');
  WriteLn(' ADD BX,Y');
  WriteLn(' Call PeekBX ; AL');
{  WriteLn(' XOR AH,AH'); {------------------}
 end;

Procedure PokeIndY;
 begin
  WriteLn('; poke indy');
  WriteLn(' INC PC');
  WriteLn(' XOR BH,BH');
  WriteLn(' Call DeekBX ; BX');
  WriteLn(' ADD BX,Y');
  writeln(' MOV CX,',OpCycles[IR]);
  WriteLn('JMP PokeBX ; AL');
 end;

Procedure Branch(Flag:string; On:boolean);
 begin
  Header;
  WriteLn(' INC PC');
  WriteLn(' TEST P,',Flag);
  if on then
   writeln(' JZ lbl',lbl)
  else
   writeln(' JNZ lbl',lbl);
  inc(lbl);
  writeln('  MOV AL,BL');
  writeln('  CBW');
  writeln('  ADD PC,AX');
  writeln(' lbl',lbl-1,':');
  Next;
 end;

Procedure BRK;
 begin
  Header;
  writeln('; push pc');
  WriteLn(' MOV AX,PC');
  Writeln(' INC AX');
  WriteLn(' INC AX');
  WriteLn(' MOV BX,S');
  WriteLn(' DEC BX');
  WriteLn(' MOV FS:[BX],AX');
  WriteLn(' DEC BX');
  writeln('; push (p or BFlag)');
  writeln(' MOV AL,P');
  writeln(' OR  AL,BFlag');
  writeln(' MOV FS:[BX],AL');
  writeln(' DEC BX');
  writeln(' MOV S,BX');
  writeln('; pc=peekw($FFFE)');
  writeln(' MOV BX,0FFFEh');
  writeln(' CALL DeekBX');
  writeln(' MOV PC,BX');
  Next;
 end;

Procedure ORA(Reg:string);
 begin
  WriteLn(' OR  ',Reg,',BYTE PTR A');
  WriteLn(' MOV BYTE PTR A,',Reg);
  Set_NZ(Reg);
  Next;
 end;

Procedure EOR;
 begin
  WriteLn(' XOR AX,A');
  WriteLn(' MOV A,AX');
  Set_NZ('AL');
  Next;
 end;

Procedure AND_;
 begin
  WriteLn(' AND AX,A');
  WriteLn(' MOV A,AX');
  Set_NZ('AL');
  Next;
 end;

Procedure ASL;
 begin
  writeln(' SHR P,1');
  WriteLn(' SHL AL,1');
  WriteLn(' RCL P,1');
  Set_NZ('AL');
 end;

Procedure LSR;
 begin
  writeln(' SHR P,1');
  WriteLn(' SHR AL,1');
  WriteLn(' RCL P,1');
  Set_NZ('AL');
 end;

Procedure ROL;
 begin
  writeln(' SHR P,1');
  WriteLn(' RCL AL,1');
  WriteLn(' RCL P,1');
  Set_NZ('AL');
 end;

Procedure ROR;
 begin
  writeln(' SHR P,1');
  WriteLn(' RCR AL,1');
  WriteLn(' RCL P,1');
  Set_NZ('AL');
 end;

Procedure BIT;
 begin
  WriteLn(' AND P,255-VFlag-NFlag-ZFlag');
  WriteLn(' MOV AH,BYTE PTR A');
  WriteLn(' AND AH,AL');
  WriteLn(' JNZ lbl',lbl); inc(lbl);
  WriteLn('  OR P,ZFlag');
  writeln(' lbl',lbl-1,':');
  writeln(' AND AL,VFlag+NFlag');
  WriteLn(' OR  P,AL');
  Next;
 end;

Procedure RTI;
 begin
  Header;
  WriteLn(' MOV BX,S');
  WriteLn(' INC BX');
  WriteLn(' MOV AL,FS:[BX]');
  WriteLn(' MOV P,AL');
  WriteLn(' INC BX');
  WriteLn(' MOV AX,FS:[BX]');
  WriteLn(' MOV PC,AX');
  WriteLn(' INC BX');
  WriteLn(' MOV S,BX');
  Next;
 end;

Procedure JSR;
 begin
  Header;
  WriteLn(' MOV AX,PC');
  WriteLn(' MOV PC,BX'); { !!! }
  WriteLn(' INC AX');
  WriteLn(' MOV BX,S');
  WriteLn(' DEC BX');
  WriteLn(' MOV FS:[BX],AX');
  WriteLn(' DEC BX');
  WriteLn(' MOV S,BX');
  Next;
 end;

Procedure JMPInd;
 begin
  Header;
  WriteLn(' Call DeekBX ; BX ');
  WriteLn(' MOV PC,BX');
  Next;
 end;

Procedure RTS;
 begin
  Header;
  WriteLn(' MOV BX,S');
  WriteLn(' INC BX');
  WriteLn(' MOV AX,FS:[BX]');
  WriteLn(' INC BX');
  WriteLn(' INC AX');
  WriteLn(' MOV PC,AX');
  WriteLn(' MOV S,BX');
  Next;
 end;

Procedure ADC;
 begin
{  WriteLn(' XOR AH,AH');}
  WriteLn(' SHR P,1');
  WriteLn(' ADC AX,A');
  WriteLn(' CLC');
  WriteLn(' OR  AH,AH');
  WriteLn(' JZ  lbl',lbl); inc(lbl);
  WriteLn('  STC');
  WriteLn(' lbl',lbl-1,':');
  WriteLn(' RCL P,1');
  Set_NZ('AL'); { !! }
  WriteLn(' MOV AH,BYTE PTR A');
  WriteLn(' MOV BYTE PTR A,AL');
  WriteLn(' AND AX,8080h');
  WriteLn(' XOR AL,AH');
  WriteLn(' JZ  lbl',lbl); inc(lbl);
  WriteLn('  OR P,VFlag');
  WriteLn('  JMP lbl',lbl); inc(lbl);
  WriteLn(' lbl',lbl-2,':');
  WriteLn('  AND P,255-VFlag');
  WriteLn(' lbl',lbl-1,':');
  Next;
 end;

Procedure SBC;
 begin
  WriteLn(' XOR P,1');
  WriteLn(' SHR P,1');
  WriteLn(' MOV BX,A');
  WriteLn(' SBB BX,AX');
  WriteLn(' CLC');
  WriteLn(' OR BH,BH');
  WriteLn(' JNZ lbl',lbl); inc(lbl);
  WriteLn('  STC');
  WriteLn(' lbl',lbl-1,':');
  WriteLn(' RCL P,1');
  Set_NZ('BL');
  WriteLn(' MOV BH,BYTE PTR A');
  WriteLn(' MOV BYTE PTR A,BL');
  WriteLn(' AND BX,8080h');
  WriteLn(' XOR BL,BH');
  WriteLn(' JZ  lbl',lbl); inc(lbl);
  WriteLn('  OR P,VFlag');
  WriteLn('  JMP lbl',lbl); inc(lbl);
  WriteLn(' lbl',lbl-2,':');
  WriteLn('  AND P,255-VFlag');
  WriteLn(' lbl',lbl-1,':');
  Next;
 end;

Procedure DEC_;
 begin
  WriteLn(' DEC AL');
  WriteLn(' Set_NZ AL');
 end;

Procedure INC_;
 begin
  WriteLn(' INC AL');
  WriteLn(' Set_NZ AL');
 end;

Procedure CMP(What:string);
 begin
  Header;
  WriteLn('  AND P,255-NFlag-ZFlag-CFlag');
  WriteLn('  XOR CX,CX');
  WriteLn('  CMP ',What); { Reg,Value }
  WriteLn('  JB  lbl',lbl); inc(lbl);
  WriteLn('   MOV CL,CFlag');
  WriteLn('  lbl',lbl-1,':');
  WriteLn('  JNE lbl',lbl); inc(lbl);
  WriteLn('   MOV CH,ZFlag');
  WriteLn('  lbl',lbl-1,':');
  WriteLn('  JAE lbl',lbl); inc(lbl);
  Writeln('   OR  CL,NFlag');
  WriteLn('  lbl',lbl-1,':');
  WriteLn('  OR CL,CH');
  WriteLn('  OR P,CL');
  Next;
 end;


Procedure RunCPU;
begin
  nz:=false;
  head:=false;
  peek:=false;
  writeln;
  case IR of
   $00 { BRK      } : BRK;
   $01 { ORA IndX } : begin PeekIndX; ORA('AL'); end;
   $05 { ORA ZPge } : begin PeekZPge; ORA('AL'); end;
   $06 { ASL ZPge } : begin PeekZPge; ASL; PokeZPge; end;
   $08 { PHP      } : begin Push(' MOV AL,P'); Next end;
   $09 { ORA Imm  } : begin Fetch; ORA('BL'); end;
   $0A { ASL      } : begin LDA; ASL; STA('AL'); end;
   $0D { ORA Abso } : begin PeekAbso; ORA('AL'); end;
   $0E { ASL Abso } : begin PeekAbso; ASL; PokeAbso end;
   $10 { BPL Rela } : Branch('NFlag',False);
   $11 { ORA IndY } : begin PeekIndY; ORA('AL'); end;
   $15 { ORA ZPgX } : begin PeekZPgX; ORA('AL'); end;
   $16 { ASL ZPgX } : begin PeekZPgX; ASL; PokeZPge; end;
   $18 { CLC      } : SetFlag('CFlag',False);
   $19 { ORA AbsY } : begin PeekAbsY; ORA('AL') end;
   $1D { ORA AbsX } : begin PeekAbsX; ORA('AL') end;
   $1E { ASL AbsX } : begin PeekAbsX; ASL; PokeAbso end;
   $20 { JSR Abso } : JSR;
   $21 { AND IndX } : begin PeekIndX; AND_ end;
   $24 { BIT ZPge } : begin PeekZPge; BIT end;
   $25 { AND ZPge } : begin PeekZPge; AND_ end;
   $26 { ROL ZPge } : begin PeekZPge; ROL; PokeZPge; end;
   $28 { PLP      } : begin Pop(' MOV P,AL'); Next; end;
   $29 { AND Imm  } : begin Imm; AND_ end;
   $2A { ROL      } : begin LDA; ROL; STA('AL') end;
   $2C { BIT Abso } : begin PeekAbso; BIT end;
   $2D { AND Abso } : begin PeekAbso; AND_ end;
   $2E { ROL Abso } : begin PeekAbso; ROL; PokeAbso end;
   $30 { BMI Rela } : Branch('NFlag',True);
   $31 { AND IndY } : begin PeekIndY; AND_ end;
   $35 { AND ZPgX } : begin PeekZPgX; AND_ end;
   $36 { ROL ZPgX } : begin PeekZPgX; ROL; PokeZPge end;
   $38 { SEC      } : SetFlag('CFlag',True);
   $39 { AND AbsY } : begin PeekAbsY; AND_ end;
   $3D { AND AbsX } : begin PeekAbsX; AND_ end;
   $3E { ROL AbsX } : begin PeekAbsX; ROL; PokeAbso; end;
   $40 { RTI      } : RTI;
   $41 { EOR IndX } : begin PeekIndX; EOR; end;
   $45 { EOR ZPge } : begin PeekZPge; EOR; end;
   $46 { LSR ZPge } : begin PeekZPge; LSR; PokeZPge; end;
   $48 { PHA      } : begin Push(' MOV AX,A'); Next end;
   $49 { EOR Imm  } : begin Imm; EOR end;
   $4A { LSR      } : begin LDA; LSR; STA('AL') end;
   $4C { JMP Abso } : begin Header; WriteLn(' MOV PC,BX'); Next end;
   $4D { EOR Abso } : begin PeekAbso; EOR end;
   $4E { LSR Abso } : begin PeekAbso; LSR; PokeAbso; end;
   $50 { BVC      } : Branch('VFlag',False);
   $51 { EOR IndY } : begin PeekIndY; EOR end;
   $55 { EOR ZPgX } : begin PeekZPgX; EOR end;
   $56 { LSR ZPgX } : begin PeekZPgX; LSR; PokeZPge end;
   $58 { CLI      } : SetFlag('IFlag',False);
   $59 { EOR AbsY } : begin PeekAbsY; EOR end;
   $5D { EOR AbsX } : begin PeekAbsX; EOR end;
   $5E { LSR AbsX } : begin PeekAbsX; LSR; PokeAbso end;
   $60 { RTS      } : RTS;
   $61 { ADC IndX } : begin PeekIndX; ADC end;
   $65 { ADC ZPge } : begin PeekZPge; ADC end;
   $66 { ROR ZPge } : begin PeekZPge; ROR; PokeZPge end;
   $68 { PLA      } : begin Pop(' MOV BYTE PTR A,AL'); Set_NZ('AL'); Next end;
   $69 { ADC Imm  } : begin Imm; ADC end;
   $6A { ROR      } : begin LDA; ROR; STA('AL') end;
   $6C { JMP Ind  } : JMPInd;
   $6D { ADC Abso } : begin PeekAbso; ADC end;
   $6E { ROR Abso } : begin PeekAbso; ROR; PokeAbso end;
   $70 { BVS      } : Branch('VFlag',True);
   $71 { ADC IndY } : begin PeekIndY; ADC end;
   $75 { ADC ZPgX } : begin PeekZPgX; ADC end;
   $76 { ROR ZPgX } : begin PeekZPgX; ROR; PokeZPge; end;
   $78 { SEI      } : SetFlag('IFlag',True);
   $79 { ADC AbsY } : begin PeekAbsY; ADC end;
   $7D { ADC AbsX } : begin PeekAbsX; ADC end;
   $7E { ROR AbsX } : begin PeekAbsX; ROR; PokeAbso; end;
   $81 { STA IndX } : begin LDA; PokeIndX; end;
   $84 { STY ZPge } : begin LDY; writeln(' XOR BH,BH'); PokeZPge; end;
   $85 { STA ZPge } : begin LDA; writeln(' XOR BH,BH'); PokeZPge; end;
   $86 { STX ZPge } : begin LDX; writeln(' XOR BH,BH'); PokeZPge; end;
   $88 { DEY      } : begin LDY; DEC_; STY('AL'); end;
   $8A { TXA      } : begin LDX; STA('AL') end;
   $8C { STY Abso } : begin LDY; PokeAbso; end;
   $8D { STA Abso } : begin LDA; PokeAbso; end;
   $8E { STX Abso } : begin LDX; PokeAbso; end;
   $90 { BCC Rela } : Branch('CFlag',False);
   $91 { STA IndY } : begin LDA; PokeIndY; end;
   $94 { STY ZPgX } : begin LDY; PokeZPgX; end;
   $95 { STA ZPgX } : begin LDA; PokeZPgX; end;
   $96 { STX ZPgX } : begin LDX; PokeZPgX; end;
   $98 { TYA      } : begin LDY; STA('AL') end;
   $99 { STA AbsY } : begin LDA; PokeAbsY; end;
   $9A { TXS      } : begin LDX; WriteLn(' MOV BYTE PTR S,AL'); Next; end;
   $9D { STA AbsX } : begin LDA; PokeAbsX; end;
   $A0 { LDY Imm  } : begin Fetch; STY('BL'); end;
   $A1 { LDA IndX } : begin PeekIndX; STA('AL') end;
   $A2 { LDX Imm  } : begin Fetch; STX('BL'); end;
   $A4 { LDY ZPge } : begin PeekZPge; STY('AL'); end;
   $A5 { LDA ZPge } : begin PeekZPge; STA('AL'); end;
   $A6 { LDX ZPge } : begin PeekZPge; STX('AL'); end;
   $A8 { TAY      } : begin LDA; STY('AL') end;
   $A9 { LDA Imm  } : begin Fetch; STA('BL') end;
   $AA { TAX      } : begin LDA; STX('AL') end;
   $AC { LDY Abso } : begin PeekAbso; STY('AL'); end;
   $AD { LDA Abso } : begin PeekAbso; STA('AL'); end;
   $AE { LDX Abso } : begin PeekAbso; STX('AL'); end;
   $B0 { BCS Rela } : Branch('CFlag',True);
   $B1 { LDA IndY } : begin PeekIndY; STA('AL'); end;
   $B4 { LDY ZPgX } : begin PeekZPgX; STY('AL'); end;
   $B5 { LDA ZPgX } : begin PeekZPgX; STA('AL'); end;
   $B6 { LDX ZPgY } : begin PeekZPgY; STX('AL'); end;
   $B8 { CLV      } : SetFlag('VFlag',False);
   $B9 { LDA AbsY } : begin PeekAbsY; STA('AL'); end;
   $BA { TSX      } : begin Header; WriteLn(' MOV AX,S'); STX('AL'); end;
   $BC { LDY AbsX } : begin PeekAbsX; STY('AL'); end;
   $BD { LDA AbsX } : begin PeekAbsX; STA('AL'); end;
   $BE { LDX AbsY } : begin PeekAbsY; STX('AL'); end;
   $C0 { CPY Imm  } : begin Fetch; CMP('BYTE PTR Y,BL'); Next; end;
   $C1 { CMP IndX } : begin PeekIndX; CMP('A,AX'); end;
   $C4 { CPY ZPge } : begin PeekZPge; CMP('Y,AX'); end;
   $C5 { CMP ZPge } : begin PeekZPge; CMP('A,AX'); end;
   $C6 { DEC ZPge } : begin PeekZPge; DEC_; PokeZPge; end;
   $C8 { INY      } : begin LDY; INC_; STY('AL'); end;
   $C9 { CMP Imm  } : begin Fetch; CMP('BYTE PTR A,BL'); end;
   $CA { DEX      } : begin LDX; DEC_; STX('AL'); end;
   $CC { CPY Abso } : begin PeekAbso; CMP('Y,AX'); end;
   $CD { CMP Abso } : begin PeekAbso; CMP('A,AX'); end;
   $CE { DEC Abso } : begin PeekAbso; DEC_; PokeAbso; end;
   $D0 { BNE Rela } : Branch('ZFlag',False);
   $D1 { CMP IndY } : begin PeekIndY; CMP('A,AX'); end;
   $D5 { CMP ZPgX } : begin PeekZPgX; CMP('A,AX'); end;
   $D6 { DEC ZPgX } : begin PeekZPgX; DEC_; PokeZPge; end;
   $D8 { CLD      } : SetFlag('CFlag',False);
   $D9 { CMP AbsY } : begin PeekAbsY; CMP('A,AX'); end;
   $DD { CMP AbsX } : begin PeekAbsX; CMP('A,AX'); end;
   $DE { DEC AbsX } : begin PeekAbsX; DEC_; PokeAbso; end;
   $E0 { CPX Imm  } : begin Fetch; CMP('BYTE PTR X,BL'); end;
   $E1 { SBC IndX } : begin PeekIndX; SBC; end;
   $E4 { CPX ZPge } : begin PeekZPge; CMP('X,AX'); end;
   $E5 { SBC ZPge } : begin PeekZPge; SBC; end;
   $E6 { INC ZPge } : begin PeekZPge; INC_; PokeZPge; end;
   $E8 { INX      } : begin LDX; INC_; STX('AL'); end;
   $E9 { SBC Imm  } : begin Imm; SBC; end;
   $EA { NOP      } : begin Header; { nothing } Next; end;
   $EC { CPX Abso } : begin PeekAbso; CMP('X,AX'); end;
   $ED { SBC Abso } : begin PeekAbso; SBC; end;
   $EE { INC Abso } : begin PeekAbso; INC_; PokeAbso; end;
   $F0 { BEQ Rela } : Branch('ZFlag',True);
   $F1 { SBC IndY } : begin PeekIndY; SBC; end;
(*
   $F2 { Extension OpCode } : begin
    if PC<$E000 then Halt(hJAM);
    Case Imm of
     $00 : begin
            Bank0^[$90]:=Bank0^[$90] or IEC.Output(Bank0^[$95],Bank0^[$A3] and $80);
            Exclude(P,CFg);
            PC:=$EDAC;
           end;
     $01 : begin
            Bank0^[$90]:=Bank0^[$90] or IEC.OutputATN(A{Bank0^[$95]});
            Exclude(P,CFg);
            PC:=$EDAC;
           end;

     $02 : begin
            Bank0^[$90]:=Bank0^[$90] or IEC.OutputSec(Bank0^[$95]);
            Exclude(P,CFg);
            PC:=$EDAC;
           end;

     $03 : begin
            Bank0^[$90]:=IEC.Input(A);
            Set_NZ(A);
            Exclude(P,CFg);
            PC:=$EDAC;
           end;
     else  Halt(hIEC);
    end;
   end;
*)
   $F5 { SBC ZPgX } : begin PeekZPgX; SBC end;
   $F6 { INC ZPgX } : begin PeekZPgx; INC_; PokeZPge; end;
   $F8 { SED      } : begin Header; WriteLn(' JMP JAM ; not supported !'); end;
   $F9 { SBC AbsY } : begin PeekAbsY; SBC end;
   $FD { SBC AbsX } : begin PeekAbsX; SBC end;
   $FE { INC AbsX } : begin PeekAbsX; INC_; PokeAbso; end;

   else WriteLn('op',Hexa(IR),' equ JAM');
  end;
 end;

var
 sep:char;
begin
{ assign output }
 assign(output,'6510.asm'); rewrite(output);

{ init }
 lbl:=0;

{ header }
 writeln(';--- 6510 Emulation');

{ opTable }
 writeln('Align 2');
 write  ('OpTable:');
 for IR:=0 to 255 do begin
  if IR mod 8 = 0 then begin
   write(#13#10'  dw'); sep:=' ';
  end;
  write(sep,'op',Hexa(IR)); sep:=',';
 end;
 writeln;

{ macro }
 writeln;
 WriteLn(';--- macro ---');
 WriteLn;
 WriteLn('OpCode Macro Number');
 WriteLn(' Align 2');
 WriteLn(' op&Number:');
 WriteLn('EndM');
 WriteLn;
 WriteLn('Set_NZ Macro Reg');
 WriteLn('Local L1,L2,L3,L4');
 WriteLn(' OR Reg,Reg');
 WriteLn(' JZ L1');
 WriteLn('  TEST Reg,NFlag');
 WriteLn('  JZ L2');
 WriteLn('   AND P,255-ZFlag');
 WriteLn('   OR  P,NFlag');
 WriteLn('  JMP L3');
 WriteLn('  L2:');
 WriteLn('   AND P,255-ZFlag-NFlag');
 WriteLn('  JMP L3');
 WriteLn(' L1:');
 WriteLn('  AND P,255-NFlag');
 WriteLn('  OR  P,ZFlag');
 WriteLn(' L3:');
 WriteLn('EndM');

{ opcodes }
 for IR:=0 to 255 do RunCPU;

{ done }
 close(output);
end.
