;-- PEEK C64 Memory

;- ASSUME FS=RAMSeg, GS=ROMSeg, DS=CIOSeg

;--- BX = PEEK(PC) AND 255

Align 2
PeekPCTable:
   ; this table will be update by a poke at 0 or 1
   ;
 dw pcRAM,pcRAM,pcRAM,pcRAM,pcRAM,pcROM,pcRAM,pcROM

Align 2
PeekPC:
 XOR EDX,EDX
 MOV SI,PC
 MOV BX,SI
 SHR BX,13
JMP [2*EBX+Offset PeekPCTable]

Align 2
pcRAM:
 MOV DL,FS:[SI]
 INC SI
 MOV BX,FS:[SI]

IF DEBUG
 MOV AX,0
 MOV DI,OFFSET A
 INT 64h
ENDIF

 MOV PC,SI
JMP [2*EDX+Offset OpTable]

Align 2
pcROM:
 MOV DL,GS:[SI]
 INC SI
 MOV BX,GS:[SI]

IF DEBUG
 MOV AX,0
 MOV DI,OFFSET A
 INT 64h
ENDIF

 MOV PC,SI
JMP [2*EDX+Offset OpTable]

;--- AL=PEEK (DI) AND 255

Align 2
PeekTable:
   ; this table will be update by a poke at 0 or 1
   ;0xxx 1xxx,2xxx,3xxx,4xxx,5xxx,6xxx,7xxx
 dw pRAM,pRAM,pRAM,pRAM,pRAM,pRAM,pRAM,pRAM
   ;8xxx,9xxx,Axxx,Bxxx,Cxxx,Dxxx,Exxx,Fxxx
 dw pRAM,pRAM,pROM,pROM,pRAM,pCIO,pROM,pROM


Align 2
PeekBX:
 MOV DI,BX
 SHR BX,12
 XOR AH,AH
JMP [2*EBX+Offset PeekTable]

Align 2
pRAM:
 MOV AL,FS:[DI]

 IF DEBUG
  PUSH AX
  PUSH BX
  MOV BX,AX
  MOV AX,2
  INT 64h
  POP  BX
  POP  AX
 ENDIF

RET

Align 2
pROM:
 MOV AL,GS:[DI]

 IF DEBUG
  PUSH AX
  PUSH BX
  MOV BX,AX
  MOV AX,2
  INT 64h
  POP  BX
  POP  AX
 ENDIF


RET

;--- PEEK($Dxxx)

PeekCIOTable:
  ; D000 D100 D200 D300 D400 D500 D600 D700
 dw rVIC,rVIC,rVIC,rVIC,rSID,rSID,rSID,rSID
  ; D800 D900 DA00 DB00 DC00 DD00 DE00 DF00
 dw rCOL,rCOL,rCOL,rCOL,rCI1,rCI2,rCOL,rCOL

Align 2
pCIO:
 MOV BX,DI
 SHR BX,8
 AND BX,0Fh

JMP [2*EBX+Offset PeekCIOTable]

Align 2
rVIC:
 MOV AL,[DI]
 IF DEBUG
  PUSH AX
  PUSH BX
  MOV BX,AX
  MOV AX,2
  INT 64h
  POP  BX
  POP  AX
 ENDIF
RET

Align 2
rSID:
 MOV AL,[DI]
 IF DEBUG
  PUSH AX
  PUSH BX
  MOV BX,AX
  MOV AX,2
  INT 64h
  POP  BX
  POP  AX
 ENDIF
RET

Align 2
rCOL:
 MOV AL,[DI]
 IF DEBUG
  PUSH AX
  PUSH BX
  MOV BX,AX
  MOV AX,2
  INT 64h
  POP  BX
  POP  AX
 ENDIF
RET

Align 2
rCI1:
 MOV BX,DI
 AND BX,15
JMP [2*EBX+Offset PeekCIA1]

Align 2
rCI2:
 MOV AL,[DI]
 IF DEBUG
  PUSH AX
  PUSH BX
  MOV BX,AX
  MOV AX,2
  INT 64h
  POP  BX
  POP  AX
 ENDIF
RET


;--- BX = DEEK (DI)

Align 2
DeekTable:
   ; this table will be update by a poke at 0 or 1
   ;0xxx 1xxx,2xxx,3xxx,4xxx,5xxx,6xxx,7xxx
 dw dRAM,dRAM,dRAM,dRAM,dRAM,dRAM,dRAM,dRAM
   ;8xxx,9xxx,Axxx,Bxxx,Cxxx,Dxxx,Exxx,Fxxx
 dw dRAM,dRAM,dROM,dROM,dRAM,dCIO,dROM,dROM


;Align 2
;DeekDI:
; MOV BX,DI
; SHR BX,12
;JMP [2*EBX+Offset DeekTable]
;Align 2

DeekBX:
 MOV DI,BX
 SHR BX,12
JMP [2*EBX+Offset DeekTable]

Align 2
dRAM:
 MOV BX,FS:[DI]

 IF DEBUG
  PUSH AX
  MOV AX,3
  INT 64h
  POP  AX
 ENDIF


RET

Align 2
dROM:
 MOV BX,GS:[DI]

 IF DEBUG
  PUSH AX
  MOV AX,3
  INT 64h
  POP  AX
 ENDIF


RET

;--- DEEK($Dxxx)

Align 2
dCIO:
 MOV BX,[DI]

 IF DEBUG
  PUSH AX
  PUSH BX
  MOV BX,AX
  MOV AX,3
  INT 64h
  POP  BX
  POP  AX
 ENDIF


RET
