;-- POKE C64 Memory

;- ASSUME ES=RAMSeg, FS=ROMSeg, DS=CIOSeg

;--- POKE(DI)

Align 2
PokeTable:
   ; this table will be update by a poke at 0 or 1
   ;0xxx 1xxx,2xxx,3xxx,4xxx,5xxx,6xxx,7xxx
 dw sZPG,sRAM,sRAM,sRAM,sRAM,sRAM,sRAM,sRAM
   ;8xxx,9xxx,Axxx,Bxxx,Cxxx,Dxxx,Exxx,Fxxx
 dw sRAM,sRAM,sRAM,sRAM,sRAM,sCIO,sRAM,sRAM


Align 2
PokeBX:
 MOV DI,BX

 IF DEBUG
  PUSH AX
  PUSH BX
  MOV BX,AX
  MOV AX,1
  INT 64h
  POP  BX
  POP  AX
 ENDIF

 SHR BX,12
JMP [2*EBX+Offset PokeTable]

Align 2
sZPG:
 MOV FS:[DI],AL
 CMP DI,2
 JB  ConfigMem
JMP NEXT

ConfigMem:
; port:=(not Bank0^[0]) or Bank0^[1];
; if  (Port and 2)=2 then KERNEL :=@KERNEL_ROM  else KERNEL :=@BANK1^[$E000];
; if  (Port and 3)=3 then BASIC  :=@BASIC_ROM   else BASIC  :=@BANK1^[$A000];
; if  (Port and 3)>0 then CHARSET:=@CHARSET_ROM else CHARSET:=@BANK1^[$D000];
; IO:=(Port and 7)>4;

 MOV AX,FS:[00]
 NOT AL
 OR  AL,AH

 MOV BX,2*7
 MOV DI,2*14

 MOV AH,AL
 AND AH,2
 JNZ SET_KERNAL
  MOV WORD PTR [BX+Offset PeekPCTable],Offset pcRAM
  MOV WORD PTR [DI+Offset PeekTable],Offset pRAM
  MOV WORD PTR [DI+Offset DeekTable],Offset dRAM

  MOV BX,2*5
  MOV DI,2*10

 REMOVE_BASIC:
  MOV WORD PTR [BX+Offset PeekPCTable],Offset pcRAM
  MOV WORD PTR [DI+Offset PeekTable],Offset pRAM
  MOV WORD PTR [DI+Offset DeekTable],Offset dRAM
 JMP KERNAL_DONE

 SET_KERNAL:
  MOV WORD PTR [BX+Offset PeekPCTable],Offset pcROM
  MOV WORD PTR [DI+Offset PeekTable],Offset pROM
  MOV WORD PTR [DI+Offset DeekTable],Offset dROM

  MOV BX,2*5
  MOV DI,2*10

  MOV AH,AL
  AND AH,1
  JZ  REMOVE_BASIC
  MOV WORD PTR [BX+Offset PeekPCTable],Offset pcROM
  MOV WORD PTR [DI+Offset PeekTable],Offset pROM
  MOV WORD PTR [DI+Offset DeekTable],Offset dROM

 KERNAL_DONE:

 MOV BX,2*13

 MOV AH,AL
 AND AH,3
 JNZ SET_CHARS
  MOV WORD PTR [BX+Offset PeekTable],Offset pRAM
  MOV WORD PTR [BX+Offset DeekTable],Offset dRAM
  JMP CHARS_DONE
 SET_CHARS:
  MOV WORD PTR [BX+Offset PeekTable],Offset pROM
  MOV WORD PTR [BX+Offset DeekTable],Offset dROM
 CHARS_DONE:

 MOV BX,2*13
 AND AL,7
 CMP AL,4
 JA  SET_CHIPS
  MOV WORD PTR [BX+Offset PokeTable],Offset sRAM
  JMP NEXT
 SET_CHIPS:
 MOV WORD PTR [BX+Offset PeekTable],Offset pCIO
 MOV WORD PTR [BX+Offset DeekTable],Offset dCIO
 MOV WORD PTR [BX+Offset PokeTable],Offset sCIO
JMP NEXT

Align 2
sRAM:
 MOV FS:[DI],AL
JMP NEXT

;--- POKE($Dxxx)

Align 2
PokeCIOTable:
  ; D000 D100 D200 D300 D400 D500 D600 D700
 dw pVIC,pVIC,pVIC,pVIC,pSID,pSID,pSID,pSID
  ; D800 D900 DA00 DB00 DC00 DD00 DE00 DF00
 dw pCOL,pCOL,pCOL,pCOL,pCI1,pCI2,pCOL,pCOL

Align 2
sCIO:
 MOV BX,DI
 SHR BX,8
 AND BX,0Fh
JMP [2*EBX+Offset PokeCIOTable]

Align 2
pVIC:
 MOV [DI],AL
JMP NEXT

Align 2
pSID:
 MOV [DI],AL
JMP NEXT

Align 2
pCOL:
 MOV [DI],AL
JMP NEXT

Align 2
pCI1:
 MOV BX,DI
 AND BX,15
JMP [2*EBX+Offset PokeCIA1]

Align 2
pCI2:
 MOV [DI],AL
JMP NEXT

