;-- VIC II Emulation
comment *
Copyright (C) 1996-98  Paul Toth (tothpaul@mygale.org)

http://www.mygale.org/~tothpaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
Align 2
 Raster dw 0
 VideoY dw 0

; BorderColor db 14

 TopOfScreen    equ 30
 BottomOfScreen equ 270
Align 2
 FirstLine dw 51
 LastLine  dw 250

IF SKIPCOUNT
 SkipFrame dw 1
; SkipCount = 4
ENDIF

 VideoMode dw Offset TextMode1
 SpriteMode dw Offset SpriteMode1

 ColorMatrix db 40 dup (0)
 VideoMatrix db 40 dup (0)
 CharsMatrix db 40 dup (0)

 BadColor dw 0D800h
 BadVideo dw 00400h

 TextCols dw 40
 TextRow  dw 0

Align 2
DrawLine:
 ADD Cycles,64

 MOV AX,Raster
 INC AX
 CMP AX,312 ; End Of Screen
 JNZ NoVBlank
  XOR AX,AX
  MOV VideoY,AX
  MOV TextRow,AX
  MOV BadColor,0D800h
  MOV BadVideo,00400h
IF SKIPCOUNT
  DEC SkipFrame
  JNS sfOk
   MOV SkipFrame,SkipCount
  sfOk:
ENDIF
  AND BYTE PTR DS:[0D011h],255-128
 NoVBlank:
 MOV Raster,AX

 MOV DS:[0D012h],AL

 TEST AH,1
 JZ  NotRaster8
  OR BYTE PTR DS:[0D011h],128
 NotRaster8:

IF SKIPCOUNT
 TEST SkipFrame,255
 JNZ OutOfScreen
ENDIF

 CMP AX,TopOfScreen
 JB  OutOfScreen
 CMP AX,BottomOfScreen
 JA  OutOfScreen

 TEST Byte Ptr DS:[0D011h],10h
 JZ DrawBorder

 CMP AX,FirstLine
 JB  DrawBorder
 CMP AX,LastLine
 JA  DrawBorder

;-- Draw Text/Graph Line

; Bad Line Condition
 SUB AX,FirstLine
 AND AX,7
 JNZ NoBadLine
  SUB Cycles,20
  MOV ES,CIOSeg ; DS
  MOV DI,offset ColorMatrix
  MOV SI,BadColor ; CIOSeg:COLOR
  MOV CX,40/4
  REP MOVSD
  MOV BadColor,SI
  MOV DI,offset VideoMatrix
  MOV SI,BadVideo ; RAMSeg:Video
  MOV DS,RAMSeg
  MOV CX,40/4
  REP MOVSD
  MOV DS,CS:CIOSeg
  MOV ES,VGASeg
  MOV BadVideo,SI

IF DEBUG
 MOV BX,Raster
 MOV DX,Offset ColorMatrix
 MOV AX,4
 INT 64h
ENDIF

 NoBadLine:

IF DEBUG
 RET
ENDIF

; Draw Left Border
 MOV AX,0F02h
 MOV DX,03C4h
 OUT DX,AX
 MOV DI,VideoY
 MOV AL,DS:[53280] ; BorderColor
 MOV CX,20/4
 REP STOSB
; Draw Line
 CALL VideoMode
 TEST BYTE PTR DS:[53269],1
 JZ NoSprite
  CALL SpriteMode
 NoSprite:
; Draw Right Border
 MOV AX,0F02h
 MOV DX,03C4h
 OUT DX,AX
 MOV AL,DS:[53280] ; BorderColor
 MOV CX,20/4
 REP STOSB
 MOV VideoY,DI

 OutOfScreen:
RET

Align 2
DrawBorder:
IF DEBUG
 RET
ENDIF
; Select all planes
 MOV AX,0F02h
 MOV DX,03C4h
 OUT DX,AX
; ES:DI = VideoY
 MOV DI,VideoY
; Draw the Line
 MOV AL,DS:[53280] ; BorderColor
 MOV AH,AL
 MOV CX,360/8
 REP STOSW
 MOV VideoY,DI
RET

Align 2
TextMode1:
 ; compute CharsMatrix
  XOR AH,AH
  MOV SI,TextCols
  DEC SI
 NextMaskTM1:
  MOV AL,[SI+offset VideoMatrix]
  MOV BX,AX
  SHL BX,3
  ADD BX,TextRow
  MOV AH,GS:[BX+0D000h] ; CHAR ROM !!
  MOV AL,1
 RevTM1:
  SHR AH,1
  RCL AL,1
 JNC RevTM1

  MOV [SI+offset CharsMatrix],AL
  DEC SI
 JNS NextMaskTM1

 INC TextRow
 AND TextRow,7

 ; put here some code to provide XScroll ... CharsMatrix[] shr XScroll

 ; draw TextCols chars

 ; plan mask
  mov dx,3C4h
  mov al,02

 ; start loop
  mov cx,TextCols
  xor si,si
  mov ch,DS:[0D021h] ; Back color 0

 NextCharTM1:
  mov bh,[si+offset CharsMatrix]
  mov bl,[si+offset ColorMatrix]

  mov ah,bh
  out dx,ax
  mov es:[di],bl
  not ah
  out dx,ax
  mov es:[di],ch

  inc di

  shr ah,4
  out dx,ax
  mov es:[di],ch
  not ah
  out dx,ax
  mov es:[di],bl

  inc di

  inc si
  dec cl
 jnz NextCharTM1
RET

Align 2
SpriteMode1:

RET
